import java.awt.FlowLayout;
import java.awt.Font;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseEvent;
import java.util.Date;
import javax.swing.JApplet;
import javax.swing.JLabel;
import javax.swing.SwingUtilities;
import javax.swing.Timer;

public class DraggableClock2 extends JApplet {
    private JLabel clock;
    private Timer timer;

    @Override
    public void init() {
        SwingUtilities.invokeLater(new Runnable() {
            public void run() {
                // v\郉x̐ݒ
                clock = new JLabel();
                Font font = clock.getFont();
                font = new Font(font.getFamily(), Font.BOLD, 20);
                clock.setFont(font);
 
                setLayout(new FlowLayout());
                add(clock);
            }
        });
    }
 
    @Override
    public void start() {
        SwingUtilities.invokeLater(new Runnable() {
            public void run() {
                // IɍsȂ
                ActionListener listener = new ActionListener() {
                    public void actionPerformed(ActionEvent event) {
                        clock.setText(new Date().toString());
                    }
                };
 
                // ^C}̐EJn
                timer = new Timer(1000, listener);
                timer.setRepeats(true);
                timer.start();
            }
        });
    }
 
    @Override
    public void stop() {
        SwingUtilities.invokeLater(new Runnable() {
            public void run() {
                // ^C}̏I
                timer.stop();
            }
        });
    }

    // hbOJnJX^}CY邽߂̃\bh
    public boolean isAppletDragStart(MouseEvent event) {
        // CTRLL[ĂAhbO
        int modifiers = event.getModifiers();
        if ((modifiers & MouseEvent.CTRL_MASK) != 0) {
            return true;
        } else {
            return false;
        }
    }
}